#!/usr/local/bin/perl

# use perl to produce listings of SY77 disks
# Riccardo Distasi, ric@irsip.na.cnr.it

#****************************************************************
# STANDARD DISCLAIMER HERE. I shall not be liable,
# even in part, for the behaviour of this program... and so on.
# You know, the legal stuff. Translation:
# If this utility reformats your hard drive DON'T SUE ME!
# (I hope it doesn't anyway ;-)
#****************************************************************

# preamble
print STDERR "Disk name? ";
chop($diskname = <STDIN>);

print <<'EndOfHeaderIsHere';
% This listing is made automatically by perl.
\documentstyle[fullpage,multicol,fancyheadings]{article}

\newcommand{\diskis}[1]{\chead{#1}}
\newcommand{\diskname}{}
\newcommand{\fileis}[1]{\subsection*{#1}}
\newenvironment{bank}%
	{\begingroup\begin{multicols}{4}\begin{enumerate}%
		\setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}%
	{\pagebreak[3]\end{enumerate}\end{multicols}\endgroup}

\nofiles
\addtolength{\voffset}{-0.5in}
\addtolength{\textheight}{0.6in}

\begin{document}
\pagestyle{fancy}
\thispagestyle{fancy}

% The disk name goes in \chead down here:
%\chead{SY77: nome\_disco}

%\fileis{file}
%\begin{bank}
%\item \begin{verbatim} %weird\,&name \end{verbatim}
% ...etc...
%\end{bank}
EndOfHeaderIsHere

print "\n\n\\diskis{$diskname}\n\n";


# directory
open(DIR, "ls *.[tT][0-9][0-9] *.[jJ][0-9][0-9]|");
$beginverb = "\\item \\begin{verbatim} ";
$endverb = "\\end{verbatim}\n";
while ($filename = <DIR>)
{
	# list a single file
	chop $filename;
	open(LIST, "voicenam $filename|");
	$printablefilename = $filename;
	$printablefilename =~ s/_/\\_/g;
	print "\\fileis{$printablefilename}\n";
	print "\\begin{bank}\n";
	while (<LIST>)
	{
		chop;
		s/ *[0-9]* : //;
		print "$beginverb $_ $endverb";
	}
	print "\\end{bank} % $printablefilename\n\n\n";
}
print "\\end{document}\n";

