#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#define EXT ".mid"

	/* ---- structure pour FileAlloc/Free ---- */
typedef struct { int fd; int fl; char *m; char *mend; } SFile;

	/* ---- macros ---- */
#define EAlloc(S) (S*)malloc(sizeof(S))

	/* ---- type ---- */
typedef unsigned char uchar;

	/* ---- SX ---- */
typedef struct {	char Status; char IdNo; char SubStatus; char GroupNo;
						char ByteCount[2]; } 	SXHead;
#define SXSize(m) ( ((SXHead*)(m))->ByteCount[0]*128+((SXHead*)(m))->ByteCount[1] +sizeof(SXHead) +2 )
#define SXChkSum(m) (SXSize(m)-2)
#define ChkSumSto(m) ( *((uchar*)(m)+SXChkSum(m))=ChkSumCalc(m) )
#define EOX 0xf7
#define STATUS 0xf0

	/* ---- CONSTANTES TG---- */
#define TG1VOICE "LM  8101VC"
#define BANKINT 0
#define BANKP1 1
#define BANKP2 2
typedef struct { char f1; uchar BankNo; uchar VoiceNo; char f[4]; } MVNo;
typedef struct { char f[31]; uchar VoiceNo; uchar Mode; } VInfo;

	/* ---- ChkSum ---- */
#define IsChkSumOk(m)  ( ChkSumCalc(m) == (char)m[(SXSize(m)-2)] )
#define SXChkSum(m) (SXSize(m)-2)
#define ChkSumSto(m) ( *((uchar*)(m)+SXChkSum(m))=ChkSumCalc(m) )
 

	/* ---- Defines, Fns pour reconnaitre les bulks, fichiers ---- */

#define memncmp(m,s) memcmp(m,s,strlen(s))

	/* -- Fonctions pour les types de fichier -- */
	/* -- Retour: pointeur sur les donnees -- */
#define SY1SYNALL "SY1 SYNALL"
char *ISSY1SYNALL(char *m)
	{ if( memncmp(m,SY1SYNALL)==0 ) return m+0x2000; else return 0; }

#define SY1ALL "SY1 ALL"
char *ISSY1ALL(char *m)
	{ if( memncmp(m,SY1ALL)==0 ) return m+0x2000; else return 0; }

	/* change d'offset selon les modes de la voix du SY stocke sur disk */
char *ISSYDMODE(char*m)
	{
	if( m[0]>10 ) return 0;
	return( m+0x2D0 );
	}

	/* ---- ChkSumCalc ---- */
char ChkSumCalc(char *mbeg)
	{
	char *m, *mend;
	uchar c=0x80;
	mend=mbeg+SXSize(mbeg)-2;
	for( m=mbeg+sizeof(SXHead); m<mend; m++) c=c-*m;
	return (char)(c&0x7f);
	}

	/* ---- FileAlloc ---- */
SFile *FileAlloc( char *Name )
	{
	SFile *SF=EAlloc(SFile);

	if(!SF) return 0;
	if( (SF->fd=open(Name,0)) ==-1 ) {printf("Couldn't open file %s.\n",Name); return 0; }
	SF->fl=lseek(SF->fd,0,2); lseek(SF->fd,0,0);
	if( (SF->m=(char*)malloc(SF->fl)) ==0) {printf("Not Enough Memory.\n"); free(SF); return 0; }
	if( (read(SF->fd,SF->m,SF->fl))!=SF->fl ) {printf("Error while reading file %s.\n",Name); free(SF); return 0; }
	SF->mend=SF->m+SF->fl;
	return SF;
	}

	/* ---- FileFree ---- */
SFile *FileFree( SFile *SF )
	{
	if(!SF) return 0;
	if(SF->m!=0)	{ free(SF->m); SF->m=0; SF->mend=0; }
	if(SF->fd!=0)	{ close(SF->fd); SF->fd=0; }
	free(SF);
	return 0;
	}

/* ---- Global ---- */
int AFF=0;
int FD=0;
SFile *SF=0;
unsigned char CHKSUM;

/* Buffer */
#define BUFSIZE 8192
char *BUF=0;
int BUFI;

	/* ---- w ---- */
void w (unsigned char c)
	{
	/*write(FD,&c,1);*/
/*	printf("%002x",c);
	if( ++AFF%4 ==0) printf(" ");
	if( AFF%16 ==0) printf("\n");
*/
	BUF[BUFI++]=c;
	if(BUFI>BUFSIZE)
		{
		write(FD,BUF,BUFI);
		BUFI=0;
		}
	CHKSUM-=c;
	}

	/* ---- w2 ---- */
void w2 (unsigned char c)
	{
	w(c/128);
	w(c%128);
	}

	/* ---- ws ---- */
void ws (char *s)
	{ while( *s!=0 ) w( *(s++) ); }

	/* ---- Head1 ---- */
char * Head1(char *m)
	{
	int i;

	for( i=0; i< 4*16+11; i++ ) w( *(m++) );
	m+=9;

	return m;
	}

	/* ---- Head2 ---- */
char * Head2(char *m)
	{
	int i;

	for( i=0; i< 4*16+11; i++ ) w( *(m++) );
	for( i=0; i< 9; i++ ) w( *(m++) );

	return m;
	}

	/* ---- Head4 ---- */
char * Head4(char *m)
	{
	int i,k;

	for( i=0; i< 4*16+11; i++ ) w( *(m++) );
	for( k=0; k<3; k++ )
		for( i=0; i< 9; i++ ) w( *(m++) );

	return m;
	}

	/* ---- AFM ---- */
char *AFM( char *m )
	{
	int i,k;

	for( i=0; i<4*4+1; i++) w( *(m++) );

	/* Env */
	for(k=0; k<6; k++)
	{
		for( i=0; i<2; i++) w( *(m++));
		w2(*(m++));
		for( i=0; i<5; i++) w(*(m++));
		w2(*(m++));
		for( i=0; i<6; i++) w(*(m++));
		for( i=0; i<4; i++) w2(*(m++));
		for( i=0; i<4*5; i++) w(*(m++));
	}

	/* ??? */ 
	for( i=0; i<9; i++) w(*(m++));

	/* Filt */
	for(k=0; k<2;k++)
		{
		for( i=0; i<4*5+1; i++) w(*(m++));
		for( i=0; i<4; i++) w2(*(m++));		
		}

		for( i=0; i<3; i++) w(*(m++));
	return m;
	}

	/* ---- m0 :1AFM mono ---- */
void m0 (char *m)
	{
	m=Head1(m);
	m=AFM(m);
	}

	/* ---- m1 : 2AFM mono ---- */
void m1 (char *m)
	{
	m=Head2(m);
	m=AFM(m);
	m=AFM(m);
	}

	/* ---- m2 : 4AFM mono ---- */
void m2 (char *m)
	{
	m=Head4(m);
	m=AFM(m);
	m=AFM(m);
	m=AFM(m);
	m=AFM(m);
	}

	/* ---- m3 1AFM poly ---- */
void m3 (char *m)
	{
	m0(m);
	}

	/* ---- m4 2AFM poly ---- */
void m4 (char *m)
	{
	m1(m);
	}

	/* ---- AWM ---- */
char *AWM( char *m )
	{
	int i,k;

	w2( *(m++) ); /* Attention may cause pbs ...verify */
	for( i=0; i<6*4+1; i++) w( *(m++) );

	/* Filt */
	for(k=0; k<2; k++)
		{
		for( i=0; i<4*5+1; i++) w(*(m++));
		for( i=0; i<4; i++) w2(*(m++));		
		}

	/* Env */
	for( i=0; i<4*4; i++) w(*(m++));
	for( i=0; i<4; i++) w2(*(m++));

	/* Fin */
	for( i=0; i<3; i++) w(*(m++));

	return m;
	}

	/* ---- m5 1AWM poly ---- */
void m5 (char *m)
	{
	m=Head1(m);
	m=AWM(m);
	}

	/* ---- m6 2AWM poly ---- */
void m6 (char *m)
	{
	m=Head2(m);
	m=AWM(m);
	m=AWM(m);
	}

	/* ---- m7 4AWM poly ---- */
void m7 (char *m)
	{
	m=Head4(m);
	m=AWM(m);
	m=AWM(m);
	m=AWM(m);
	m=AWM(m);
	}

	/* ---- m8 1AFM & 1AWM ---- */
void m8 (char *m)
	{
	m=Head2(m);
	m=AFM(m);
	m=AWM(m);
	}

	/* ---- m9 2AFM & 2AWM ---- */
void m9 (char *m)
	{
	m=Head4(m);
	m=AFM(m);
	m=AFM(m);
	m=AWM(m);
	m=AWM(m);
	}

	/* ---- ma Drum Set ---- */
void ma (char *m)
	{
	int i;

		/* header */
	for(i=0; i<4*16+2; i++) w(*(m++));

		/* drums */
	for(i=0; i<61; i++)
		{
		w(*(m++)); w(*(m++));
		w2(*(m++));
		w(*(m++)); w(*(m++)); w(*(m++)); w(*(m++));
		}
	}

	/* ---- d2mHeader ---- */
void d2mHeader( char mode, char no )
	{
	int i;

	static lgn[]={ 0x00, 0x638, 0, 0x34a,
						0x638, 0x155, 0x24e, 0x440, 
						0x443, 0x82a, 0x444 };
	w(0xF0); w(0x43); w(0x0); w(0x7A);
	w( lgn[mode]/256 ); w( lgn[mode]%256 );
	CHKSUM=0x00;
	ws( TG1VOICE );
	for(i=0; i<4*3+3; i++ )	w(0);
	w(no);
	}

	/* ---- d2m ---- */
void d2m( char *m )
	{
	int i;
	void (*f[])(char*)={	m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, ma };

	m= ( ISSY1SYNALL(m)!=0 ) ? ISSY1SYNALL(m) : ISSY1ALL(m);
	if(!m)
		{
		printf("Not a SY-77 disk dump.\n");
		return;
		}
	
	for( i=0; i<64; i++ )
		{
			/* d2mHeader( *m, ess ); */
		d2mHeader( *m, i );
		if( (unsigned char)*m>10 ) { printf("Integrity error %x %d.\n",*m,i); exit(20); }
		f[*m](m);
		w( CHKSUM&0x7f );
		w(0xF7);
			/* tient compte de la bank d */
		if(i<47) 		m+=0x2d0;
		else if(i<48) 	m+=0x3d0;
		else 				m+=0x560;
		}
	}

/* ---- NewName ---- */
char *NewName(char *Name)
	{
	static char s1[120];
	char *s;

	strcpy(s1,Name);
	for( s=s1+strlen(s1)-1; s!=s1 && *s!='.'; s--);
	if(s==s1) s=s1+strlen(s1);
	strcpy(s,EXT);
	return s1;
	}

	/* ---- main ---- */
void main(int argc, char **argv)
	{
	
	if( argc==1 || !strcmp(argv[1],"-h") ) 
		{printf("Usage :\nsy2tg77 <sy77 disk dump> [<sy77 disk dump>...]\n"); 
		printf("  In the same directory, the equivalent midi file \n");
		printf("  will be created. \n");
		exit(0);
		}

	if( (BUF=(char*)malloc(BUFSIZE))==0 ) { printf("Not enough memory\n"); exit(0); }


	while(--argc>0)
		{
	
		SF=FileAlloc( *(++argv) );
		if( !SF ) { printf("File not found.\n"); free(BUF); exit(1); }
	
		FD=creat(NewName(*argv),0);
		if( FD==-1 ) { printf("Cannot create the new file.\n"); free(BUF); exit(1);}
		BUFI=0;

		d2m( SF->m );

		write( FD, BUF, BUFI );
		close(FD);
	
		SF=FileFree(SF);
		printf( "%s --> %s\n",*argv,NewName(*argv) );
		}

	if( BUF ) free( BUF );

	exit(0);
	}
